﻿/* Cascading Dropdowns v3.524
 * -----------------------------
 * Created by Alexander Bautz
 * alexander.bautz@gmail.com
 * http://spjsblog.com
 * Copyright (c) 2009-2015 Alexander Bautz (Licensed under the MIT X11 License)
 * ---------------------------------------------
*/

/*
JSLint
var _spPageContextInfo, $, alert, setTimeout, document, location;
*/

/* SP2013 */
if(typeof _spPageContextInfo !== "undefined"){
	if(_spPageContextInfo.webUIVersion === 15){
		var L_Menu_BaseUrl = _spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl : "";
		var L_Menu_LCID = _spPageContextInfo.currentLanguage.toString();
	}
}

var spjs = spjs || {};
// The file assetpickers.js in SP365 overwrites the $ namespace. 
spjs.$ = spjs.$ || $;

spjs.casc = {
	"version":3.524,
	"versionDate":"August 21, 2015",
	"isSP07":typeof _spPageContextInfo === "undefined" || _spPageContextInfo.webUIVersion === undefined,
	"isDispForm":location.pathname.toLowerCase().indexOf("dispform.aspx") > -1,
	"multi":{},
	"data":{"multichoiceDelimiter":";\n"},
	"cssDone":false,
	"getLocalized":function(){
		var lcid = "";
		if(!spjs.casc.isSP07){
			lcid = _spPageContextInfo.currentLanguage.toString();
		}else{
			lcid = L_Menu_LCID;			
		}
		switch(lcid){
			case "1044":
				spjs.casc.text = {
					"invalidData":"Valget \"{0}\" er ikke gyldig",
					"buttonTextAdd":"Legg til",
					"buttonTextRemove":"Fjern",
					"unselectedOptions":"Tilgjengelige valg",
					"selectedOptions":"Valgte elementer"
				};
			break;
			case "1053":
				spjs.casc.text = {
					"invalidData":"Alternativ \"{0}\" är inte giltigt",
					"buttonTextAdd":"Lägg till",
					"buttonTextRemove":"Ta bort",
					"unselectedOptions":"Tillgängliga alternativ",
					"selectedOptions":"Valda alternativ"
				};
			break;
			default:
				spjs.casc.text = {
					"invalidData":"The selection \"{0}\" is not valid",
					"buttonTextAdd":"Add",
					"buttonTextRemove":"Remove",
					"unselectedOptions":"All options",
					"selectedOptions":"Selected options"
				};
		}
	},
	"css":function(){
		spjs.casc.cssDone = true;
		var cb = [];
		cb.push("<style type='text/css'>");
		cb.push(".spjs_casc_notvalid select{border:1px red dashed;padding:2px;}");
		cb.push("select.spjs_selected.spjs_casc_multi{background-color:#B0D39C;}");
		cb.push("select.spjs_unselected.spjs_casc_multi{background-color:#f5f5f5;}");
		cb.push("select.spjs_casc_multi{width:100%;height:125px;box-sizing:border-box;}");
		cb.push(".spjs_casc_info{font-size:12px;color:#444;cursor:default;}");		
		cb.push("</style>");
		spjs.$(document).ready(function(){
			spjs.$("body").append(cb.join(""));
		});
	},
	"debugWrite":function(str,style){
		spjs.$("#spjs_casc_debug").append("<div style='"+style+"'>"+str+"</div>");
	},
	"init":function(argObj){		
		var dID, myMatch, s, i, autofill;
		if(!spjs.casc.cssDone){
			spjs.casc.css();
		}
		if(spjs.casc.isDispForm){
			return;
		}
		if(argObj.multichoiceDelimiter !== undefined){
			spjs.casc.data.multichoiceDelimiter = argObj.multichoiceDelimiter;
		}
		spjs.casc.getLocalized();
		argObj.numberOfDropdowns = argObj.lookupListFields.length;
		dID = argObj.thisListFields[0].split(":")[0];
		if(typeof dID === "object"){
			dID = dID.fin;
		}
		spjs.casc.multi[dID] = {};
		spjs.$.each(argObj.thisListFields,function(i,v){			
			if(v.split(":").length > 1 && v.split(":")[1] === "multi"){
				spjs.casc.multi[dID][v.split(":")[0]] = true;
				argObj.thisListFields[i] =  v.split(":")[0];				
			}else{
				spjs.casc.multi[dID][v] = false;
			}
		});
		spjs.casc.data[dID] = argObj;
		if(argObj.debug){
			spjs.$("body").prepend("<div style='font-size:14px;color:gray;'>[SPJS Cascading dropdowns v"+spjs.casc.version+"]</div><div id='spjs_casc_debug'></div>");
			alert("[Cascading dropdowns]: Debug is activated.");
			spjs.casc.debugWrite("Function called with these arguments:","font-weight:bold");
			spjs.$.each(argObj,function(x,y){
				spjs.casc.debugWrite(x+":"+y,"margin-left:10px");
			});
		}
		spjs.casc.fields = {};
		spjs.$("td.ms-formbody").each(function(){
			myMatch = spjs.$(this).html().match(/FieldName="(.+)"\s+FieldInternalName="(.+)"\s+FieldType="(.+)"\s+/);	
			if(myMatch!==null){
				spjs.casc.fields[myMatch[2]] = {"type":myMatch[3],"disp":myMatch[1],"field":this.parentNode};
			}		
		});
		if(spjs.$("#"+dID+"_casc").length > 0){
			return;
		}	
		spjs.$.each(argObj.thisListFields,function(i,v){
			s = spjs.casc.fields[(v.split(":").length > 1 ? v.split(":")[0] : v)];
			if(s === undefined){ 
				alert("The fieldname \""+v+"\" specified in \"thisListFields\" does not exist.\nYou must use \"FieldInternalName\" to identify the fields.");
				return;
			}
			if(spjs.casc.multi[dID][v]){
				if(s.type.match("Note") === null){
					alert("[Cascading dropdowns]\n\nWhen using multi select you must change the field \""+s.disp+"\" to type \"Multiple lines of text: Plain text\"");
					return false;
				}
			}else if(s.type.match("Text") === null){
				alert("[Cascading dropdowns]\n\nYou must change the field \""+s.disp+"\" to type \"Single lines of text\"");
				return false;
			}
			if(!spjs.casc.data[dID].debug){
				spjs.$(s.field).find('input:text,textarea').hide();
			}
			var buffer = [];					
			if(spjs.casc.multi[dID][v]){
				buffer.push("<table cellpadding='0' cellspacing='0' style='width:100%;'>");	
				buffer.push("<tr id='"+v+"_casc_unselectedWrap' style='padding:2px;'>");
					buffer.push("<td valign='top'>");
						buffer.push("<div class='spjs_casc_info'>"+spjs.casc.text.unselectedOptions+"</div>");
						buffer.push("<select class='spjs_unselected spjs_casc_multi' id='"+v+"_casc_unselected' multiple></select>");
					buffer.push("</td>");
				buffer.push("</tr>");
				buffer.push("<tr>");
					buffer.push("<td valign='top' id='"+v+"_casc_btnWrap' style='text-align:center;padding-top:10px;'>");
						buffer.push("<input id='"+v+"_casc_btnAdd' type='button' onclick='spjs.casc.add(\""+v+"\",\""+dID+"\","+i+")' value='"+spjs.casc.text.buttonTextAdd+"' disabled>");
						buffer.push("<input id='"+v+"_casc_btnRemove' type='button' onclick='spjs.casc.remove(\""+v+"\",\""+dID+"\","+i+")' value='"+spjs.casc.text.buttonTextRemove+"' disabled>");
					buffer.push("</td>");
				buffer.push("</tr>");
				buffer.push("<tr id='"+v+"_casc_selectedWrap'>");
					buffer.push("<td valign='top'>");
						buffer.push("<div class='spjs_casc_info'>"+spjs.casc.text.selectedOptions+"</div>");
						buffer.push("<select class='spjs_selected spjs_casc_multi' id='"+v+"_casc' multiple></select>");
					buffer.push("</td>");
				buffer.push("</tr>");
				buffer.push("</table>");
				spjs.$(s.field).find('.ms-formbody span:eq(0)').prepend(buffer.join(""));				
				spjs.$("#"+v+"_casc_unselected")
					.dblclick(function(){spjs.casc.add(v,dID,i);})
					.focus(function(){spjs.$("#"+v+"_casc_btnRemove").attr("disabled","disabled");spjs.$("#"+v+"_casc_btnAdd").removeAttr("disabled");});
				spjs.$("#"+v+"_casc")
					.dblclick(function(){spjs.casc.remove(v,dID,i);})
					.focus(function(){spjs.$("#"+v+"_casc_btnAdd").attr("disabled","disabled");spjs.$("#"+v+"_casc_btnRemove").removeAttr("disabled");});
			}else{
				buffer.push("<select class='spjs_selected' id='"+v+"_casc'></select>");
				spjs.$(s.field).find('.ms-formbody span:eq(0)').prepend(buffer.join(""));
				spjs.$("#"+v+"_casc").change(function(){
					spjs.casc.change(dID,i);
				});
			}	
		});	
		i = 0;
		autofill = argObj.autoselectSingleOption === true;
		while(i<argObj.numberOfDropdowns){	
			if(i===0 || spjs.$("#"+argObj.thisListFields[i-1]+"_casc").parents("td.ms-formbody:first").find('input:text,textarea').val() !== ""){
				spjs.casc.fill(dID,true,i,autofill);				
			}else{
				if(argObj.hideEmptyDropdowns){
					spjs.$("#"+argObj.thisListFields[i]+"_casc").parents("td.ms-formbody").parent().hide();
				}
			}
			spjs.casc.load(argObj.thisListFields[i],argObj.clearInvalidSelection);
			i += 1;
		}
		setTimeout(function(){
			if(typeof spjs.dffs === "undefined"){
				spjs.$(".spjs_casc_notvalid").show();
			}
		},1000);
	},
	"add":function(id,dID,index){
		var s, u;
		s = spjs.$("#"+id+"_casc");
		u = spjs.$("#"+id+"_casc_unselected");		
		u.find("option:selected").appendTo(s);
		s.find("option:selected").removeAttr("selected");
		spjs.casc.change(dID,index);	
	},
	"remove":function(id,dID,index){
		var s, u;
		s = spjs.$("#"+id+"_casc");
		u = spjs.$("#"+id+"_casc_unselected");		
		s.find("option:selected").appendTo(u);
		spjs.casc.change(dID,index);
		u.find("option:selected").removeAttr("selected");
	},
	"hideEmpty":function(){
		// Used from DFFS
		if(spjs.casc.data !== undefined){
			spjs.$.each(spjs.casc.data,function(i,o){
				if(o.hideEmptyDropdowns){
					spjs.$.each(o.thisListFields,function(j,f){
						if(spjs.$("#"+f+"_casc option:selected").text() === ""){
							spjs.$("#"+f+"_casc").parents("td.ms-formbody").parent().hide();
						}
					});
				}
			});
		}
	},
	"clear":function(dID,clearDropdownsAfterThis){
		var config, c, u, n;
		config = spjs.casc.data[dID];
		while(clearDropdownsAfterThis<config.numberOfDropdowns){
			c = spjs.$('#'+config.thisListFields[clearDropdownsAfterThis]+'_casc');
			u = spjs.$('#'+config.thisListFields[clearDropdownsAfterThis]+'_casc_unselected');
			n = c.parents("td.ms-formbody:first").find('input:text,textarea');
			n.val("").blur();
			c.html("");
			u.html("");
			if(config.hideEmptyDropdowns){
				c.parents("td.ms-formbody").parent().hide();
			}		
			clearDropdownsAfterThis += 1; 
		}
	},
	"load":function(fin,clear){		
		var inp, sel, unsel, t, match;
		if(spjs.casc.fields[fin] === undefined){
			return;
		}
		inp = spjs.$(spjs.casc.fields[fin].field).find('input:text,textarea');
		sel = spjs.$(spjs.casc.fields[fin].field).find('select.spjs_selected');
		t = sel;
		unsel = spjs.$(spjs.casc.fields[fin].field).find('select.spjs_unselected');
		if(unsel.length > 0){
			t = unsel;
		}
		if(inp.val() !== ""){
			match = false;
			spjs.$.each(inp.val().split(spjs.casc.data.multichoiceDelimiter),function(i,v){
				t.find("option").each(function(){				
					if(spjs.$(this).text() === v){
						spjs.$(this).attr("selected","selected");
						match = true;
					} 
				}); 
			});
			if(match === false){
				if(clear){					
					spjs.$(spjs.casc.fields[fin].field).addClass("spjs_casc_notvalid").attr("title",spjs.casc.text.invalidData.replace("{0}",inp.val()));
					inp.val("");
				}else{
					sel.append("<option value='' disabled='disabled' selected='selected'>"+inp.val()+"</option>");
					spjs.$(spjs.casc.fields[fin].field).addClass("spjs_casc_notvalid").attr("title",spjs.casc.text.invalidData.replace("{0}",inp.val()));
				}				
			}else{
				if(unsel.length > 0){
					spjs.$("#"+fin+"_casc").append(spjs.$("#"+fin+"_casc_unselected").find("option:selected"));
					spjs.$("#"+fin+"_casc").find("option:selected").removeAttr("selected");
				}
			}
		}
	},
	"change":function(dID,index){
		spjs.$(".spjs_casc_notvalid").removeClass("spjs_casc_notvalid");
		var config, curr, curr_inp, curr_selected, next, next_inp, multi;
		config = spjs.casc.data[dID];
		curr = spjs.$('#' + config.thisListFields[index] + '_casc');
		multi = spjs.$(curr).hasClass("spjs_casc_multi");
		curr_inp = curr.parents("td.ms-formbody:first").find('input:text,textarea');
		if(config.numberOfDropdowns >= (index+1)){
			curr_selected = [];
			spjs.$.each(curr.find((multi ? "option" : "option:selected")),function(i,o){
				curr_selected.push(spjs.$(o).text());
			});
			if(String(curr_selected) === config.dropDownDefaultvalue){
				curr_inp.val("");
			}else{
				if(multi){
					curr_inp.val(curr_selected.length > 0 ? curr_selected.join(spjs.casc.data.multichoiceDelimiter) + spjs.casc.data.multichoiceDelimiter : ""); 
				}else{
					curr_inp.val(String(curr_selected)); 
				}				
			}
			curr_inp.blur();
			if(String(curr_selected) !== config.dropDownDefaultvalue && String(curr_selected) !== ""){
				if(config.numberOfDropdowns>(index+1)){ 
					next = spjs.$('#' + config.thisListFields[(index+1)] + '_casc');
					next_inp = next.parents("td.ms-formbody:first").find('input:text,textarea');				
					next_inp.val("");
					spjs.casc.fill(dID,false,(index+1),true);
					if(!multi){
						spjs.casc.clear(dID,(index+2));
					}else{
						spjs.casc.change(dID,(index+1));
					}
				}
			}else{
				spjs.casc.clear(dID,(index+1));
			}
		}
	},
	"fill":function(dID,load,index,autoFill){		
		var config, ts, multi, f, query, orQuery, cTxt, viewFields, res, uTracker, b, ov, ovPrefix;
		config = spjs.casc.data[dID];
		if(config.thisListFields[index] === undefined){
			return;
		}
		if(config.debug){			
			spjs.casc.debugWrite("Populating this field","font-weight:bold");
			spjs.casc.debugWrite(config.thisListFields[index],"");
		}
		multi = spjs.$("#"+config.thisListFields[index]+"_casc").hasClass("spjs_casc_multi");
		if(multi){
			ts = spjs.$("#"+config.thisListFields[index]+"_casc_unselected");
		}else{
			ts = spjs.$("#"+config.thisListFields[index]+"_casc");
		}		
		ts.html("");
		query = [];		
		spjs.$.each(config.lookupListFields,function(i,provFIN){
			orQuery = [];
			if(spjs.$("#"+config.thisListFields[i]+"_casc").hasClass("spjs_casc_multi")){
				f = "option";
			}else{
				f = "option:selected";
			}
			spjs.$.each(spjs.$("#"+config.thisListFields[i]+"_casc").find(f),function(j,t){
				cTxt = spjs.$(t).text();					
				if(cTxt !== "" && cTxt !== config.dropDownDefaultvalue && i<index){
					cTxt = cTxt.replace(/&/g,'&amp;');
					orQuery.push("<Eq><FieldRef Name='"+provFIN+"' /><Value Type='Text'>"+cTxt+"</Value></Eq>");
				}
				if(j>0 && orQuery.length > 0){
					orQuery.unshift("<Or>");
					orQuery.push("</Or>");
				}
			});
			if(orQuery.length > 0){
				if(i>0){
					query.unshift("<And>");
				}
				query.push(orQuery.join(""));
				if(i>0){
					query.push("</And>");
				}
			}
		});
		query = query.join("");
		if(query===""){
			query = "<IsNotNull><FieldRef Name='"+config.lookupListFields[0]+"' /></IsNotNull>";
		}
		query = "<Where>"+query+"</Where>";
		query += "<OrderBy><FieldRef Name='"+config.lookupListFields[index]+"' Ascending='TRUE'/></OrderBy>";	
		viewFields = config.lookupListFields.concat('ID');
		res = spjs.casc.query({"listName":config.lookupList,"listBaseUrl":config.lookupListBaseUrl,"query":query,"viewFields":viewFields}); 
		if(config.debug){			
			spjs.casc.debugWrite("CAML query","font-weight:bold");
			spjs.casc.debugWrite(query.split("<").join("&lt;").split(">").join("&gt;"),"");
			spjs.casc.debugWrite("Looking for values in this field","font-weight:bold");
			spjs.casc.debugWrite(config.lookupListFields[index],"");		
		}
		if(res.count === -1){
			alert("[Cascading dropdowns]: An error occurred.\n\nPlease enter the setup and verify that the list GUID or display name and the BaseUrl are correct.");
		}else if(res.count>0){
			b = [];		
			uTracker = {};
		    spjs.$.each(res.items, function(idx,item){	     
				ov = item[config.lookupListFields[index]];
				ovPrefix = [];
				spjs.$.each(config.lookupListFields,function(fi,fn){
					if(index > fi){
						ovPrefix.push(item[fn]);
					}
				});
				if(ovPrefix.length > 0){
					ovPrefix = ovPrefix.join(" > ")+" > ";
				}
				if(ov === null){
					return;
				}
				if(uTracker[ov] === undefined){
					uTracker[ov] = 1;
				}else{
					return;
				}			
				if(ov.split(';#').length>1){ 
					ov = ov.split(';#')[1];
				}
				ovPrefix = String(ovPrefix).split("'").join("&#39;").split("\"").join("&#34;");
				b.push("<option title='"+ovPrefix+ov+"' value='"+item.ID+"'>"+ov+"</option>");
		    });
		    if(config.debug){
				spjs.casc.debugWrite("Number of items returned","font-weight:bold");
				spjs.casc.debugWrite(b.length,"");
				if(b.length === 0){
					spjs.casc.debugWrite("*** Please note that this debug panel cannot determin if the fieldname: \""+config.lookupListFields[index]+"\" in the lookup list is correct.","color:red");
					spjs.casc.debugWrite("*** If you are not getting the options you expected, verify the FieldInternalName: \""+config.lookupListFields[index]+"\" in the lookup list: \""+config.lookupList+"\"","color:red");
				}
			}
		    if(b.length === 0){
				if(config.hideEmptyDropdowns){
					ts.parents("td.ms-formbody").parent().hide();
				}
			}else{
				if(!spjs.casc.multi[dID][config.thisListFields[index]]){
					b.unshift("<option value='0'>"+config.dropDownDefaultvalue.replace(/</,'&lt;').replace(/>/,'&gt;')+"</option>");
				}
				ts.html(b.join(""));
				if(typeof spjs.dffs === "undefined"){
					ts.parents("td.ms-formbody").parent().show();
				}
			}
			if(config.autoselectSingleOption === undefined){
				config.autoselectSingleOption = true;
			}
			if(b.length === (multi ? 1 : 2) && config.autoselectSingleOption && autoFill){
				if(multi){
					ts.find("option:last").prop("selected","selected").trigger("dblclick");
				}else{
					ts.next().val(ts.find("option:last").text()).trigger("blur");
				}
				ts.find("option:last").prop("selected","selected");		
				setTimeout(function(){
					spjs.casc.fill(dID,load,(index+1),autoFill);
				},100);
			}
			if(multi){
				spjs.$("#"+config.thisListFields[index]+"_casc option").each(function(i,o){
					if(spjs.$("#"+config.thisListFields[index]+"_casc_unselected").find("option[value='"+spjs.$(o).val()+"']").length > 0){
						spjs.$("#"+config.thisListFields[index]+"_casc_unselected").find("option[value='"+spjs.$(o).val()+"']").remove();						
					}
				});
			}
			// DFFS read only
			if(ts.parents('tr:first').find("td.dffs-readonly-inner").length > 0){
				ts.parents('tr:first').find("td.dffs-readonly-inner div.dffs_tdWrap").html(ts.next().val());
			}
		}else if(res.count===0){
			ts.parents("td.ms-formbody").parent().hide();
		}		
	},
	"query":function(argObj){
		if(argObj.listBaseUrl === undefined || argObj.listBaseUrl.toLowerCase() === "{currentsite}"){
			argObj.listBaseUrl = L_Menu_BaseUrl;
		}
		var result, xmlWrap;
		result = {'count':-1,items:[]};	
		xmlWrap = [];
		xmlWrap.push("<?xml version='1.0' encoding='utf-8'?>");
		xmlWrap.push("<soap:Envelope xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns:xsd='http://www.w3.org/2001/XMLSchema' xmlns:soap='http://schemas.xmlsoap.org/soap/envelope/'>");
		xmlWrap.push("<soap:Body>");
		xmlWrap.push('<GetListItems xmlns="http://schemas.microsoft.com/sharepoint/soap/">');
		xmlWrap.push('<listName>' + argObj.listName + '</listName>');
		xmlWrap.push('<query><Query xmlns="">');
		xmlWrap.push(argObj.query);
		xmlWrap.push('</Query></query>');
		xmlWrap.push('<viewFields><ViewFields xmlns="">');
		spjs.$.each(argObj.viewFields, function(idx, field){
			xmlWrap.push('<FieldRef Name="' + field + '"/>');
		});
		xmlWrap.push('</ViewFields></viewFields>');
		xmlWrap.push('<rowLimit>10000</rowLimit>');
		xmlWrap.push('<queryOptions><QueryOptions xmlns=""><IncludeMandatoryColumns>FALSE</IncludeMandatoryColumns>');
		xmlWrap.push('</QueryOptions></queryOptions>');
		xmlWrap.push('</GetListItems>');
		xmlWrap.push("</soap:Body>");
		xmlWrap.push("</soap:Envelope>");
		xmlWrap = xmlWrap.join("");	
		spjs.$.ajax({
			async:false,
			type:"POST",
			url:argObj.listBaseUrl + '/_vti_bin/lists.asmx',
			contentType:"text/xml; charset=utf-8",
			processData:false,
			data:xmlWrap,
			dataType:"xml",
			success:function(data){
				result.count = parseInt(spjs.$(data).filterNode("rs:data").attr('ItemCount'),10);
				spjs.$(data).filterNode('z:row').each(function(idx, itemData){
					var fieldValObj, value;
					fieldValObj = {};
					spjs.$.each(argObj.viewFields,function(i,field){
						value = spjs.$(itemData).attr('ows_' + field);
						if(value === undefined){
							value = null;
						}
						fieldValObj[field]=value;
					});
					result.items.push(fieldValObj);
				});
			},
			error:function(xhr){/*empty*/}
		});
		return result;
	}
};

// http://www.steveworkman.com/html5-2/javascript/2011/improving-javascript-xml-node-finding-performance-by-2000/
spjs.$.fn.filterNode = function(name) {
	return this.find('*').filter(function() {
		return this.nodeName === name;
	});
};